CREATE TABLE IF NOT EXISTS `wsbase` ( 
            `pageTitle` tinytext       NULL, 
            `prevWeb`   tinyint(2)     unsigned NOT NULL default '1',
            `prevAct`   tinyint(2)     unsigned NOT NULL default '1',
            `prevPDF`   tinyint(2)     unsigned NOT NULL default '1',
            `activeLog` tinyint(2)     unsigned NOT NULL default '1',
            `vClock`    tinyint(2)     unsigned NOT NULL default '1',
            `effectAct` tinyint(2)     unsigned NOT NULL default '1',
            `sepAdr`    tinyint(2)     unsigned NOT NULL default '1',
            `compPath`  tinyint(2)     unsigned NOT NULL default '1',
            `arboLink`  tinyint(2)     unsigned NOT NULL default '1',
            `dynWin`    tinyint(2)     unsigned NOT NULL default '1',
            `linkWin`   tinyint(2)     unsigned NOT NULL default '1',
            `sendMail`  tinyint(2)     unsigned NOT NULL default '1',
            `actConf`   tinyint(2)     unsigned NOT NULL default '1',
            `clicl`     tinyint(2)     unsigned NOT NULL default '1',
            `clicr`     tinyint(2)     unsigned NOT NULL default '1',
            `clicd`     tinyint(2)     unsigned NOT NULL default '1',
            `memoMax`   int(10)        unsigned NULL,
            `execMax`   int(10)        unsigned NULL,
            `postMax`   int(10)        unsigned NULL,
            `timeMax`   int(10)        unsigned NULL,
            `uploMax`   int(10)        unsigned NULL,
            `lifeMax`   int(10)        unsigned NULL,             
            `diapoSp`   int(8)         unsigned NULL
            ) DEFAULT CHARSET=utf8;
            
CREATE TABLE IF NOT EXISTS `wslog` (
            `idope`     int(10)        unsigned NOT NULL auto_increment, 
            `idaction`  tinyint(8)     unsigned NOT NULL default '1', 
            `idresult`  tinyint(2)     unsigned NOT NULL default '1', 
            `iddate`    datetime       NOT NULL default '0000-00-00 00:00:00',  
            `username`  tinytext       NOT NULL, 
            `path`      tinytext       NOT NULL, 
            `file`      tinytext       NOT NULL, 
            `ipadr`     tinytext       NOT NULL, 
            `verbose`   text           NULL,            
            `content`   text           NULL, 
             PRIMARY KEY (`idope`)
            ) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            
CREATE TABLE IF NOT EXISTS `wsuser` ( 
            `idUser`    int(10)        unsigned NOT NULL auto_increment, 
            `typeUser`  tinyint(3)     unsigned NOT NULL default '1',            
            `nomUser`   varchar(64)    default NULL,
            `logUser`   varchar(64)    default NULL,
            `passUser`  varchar(64)    default NULL,
            `serveurs`  varchar(64)    default NULL,
            `langUser`  varchar(64)    default NULL,
            `styleUser` varchar(64)    default NULL,
            `visuUser`  varchar(64)    default NULL,
            `triUser`   varchar(64)    default NULL,
            `varsUser`  tinytext       NOT NULL, 
            `webUser`   tinyint(2)     unsigned NOT NULL default '1', 
            `arboUser`  tinyint(2)     unsigned NOT NULL default '1', 
            `auth1`     varchar(2)     NULL default 'on',
            `auth2`     varchar(2)     NULL default 'on',
            `auth3`     varchar(2)     NULL default 'on',
            `auth4`     varchar(2)     NULL default 'on',
            `auth5`     varchar(2)     NULL default 'on',
            `auth6`     varchar(2)     NULL default 'on',
            `auth7`     varchar(2)     NULL default 'on',
            `auth8`     varchar(2)     NULL default 'on',
             PRIMARY KEY (`idUser`)            
            ) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            
CREATE TABLE IF NOT EXISTS `wsserver` (
            `idServeur`    int(10)     unsigned NOT NULL auto_increment, 
            `typeServeur`  tinyint(2)  unsigned NOT NULL default '1',
            `triServeur`   tinyint(8)  unsigned NOT NULL,
            `nomServeur`   tinytext    NOT NULL, 
            `rootServeur`  tinytext    NOT NULL, 
            `repServeur`   tinytext    NOT NULL, 
            `startServeur` tinytext    NOT NULL, 
            `adrServeur`   tinytext    NOT NULL, 
            `logServeur`   tinytext    NOT NULL, 
            `passServeur`  tinytext    NOT NULL, 
            `portServeur`  tinytext    NOT NULL,
            `protectIndex` tinyint(2)  unsigned NOT NULL default '1',
            `protectHtacc` tinyint(2)  unsigned NOT NULL default '1',
            `binServeur`   tinyint(2)  unsigned NOT NULL default '1',
          `protectServeur` tinyint(2)  unsigned NOT NULL default '1',
             PRIMARY KEY (`idServeur`)
            ) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            
CREATE TABLE IF NOT EXISTS `wsasso` (
            `idasso`       int(10)     unsigned NOT NULL auto_increment, 
            `type`         varchar(10) default NULL,
            `libelle`      varchar(64) default NULL,
            `mime`         varchar(64) default NULL,
            `action1`      varchar(64) default NULL,
            `action2`      varchar(64) default NULL,
             PRIMARY KEY (`idasso`)
            ) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
              
CREATE TABLE IF NOT EXISTS `wsfiles` (
            `idfiles`      int(10)     unsigned NOT NULL auto_increment, 
            `nom`          tinytext    NOT NULL,        
            `commentaires` text        NULL,
            `version`      tinytext    NULL,            
            `favoris`      tinyint(2)  unsigned NOT NULL default '1',
             PRIMARY KEY (`idfiles`)
            ) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            
            
INSERT INTO `wsbase` (`pageTitle`, `prevWeb`, `prevAct`, `prevPDF`, `activeLog`,
   `vClock`, `effectAct`, `sepAdr`, `compPath`, `arboLink`, `dynWin`,  
   `linkWin`, `sendMail`, `actConf`, `clicl`, `clicr`, `clicd`, `memoMax`, 
   `execMax`, `postMax`, `timeMax`, `uploMax`, `lifeMax`, `diapoSp`) VALUES 
   ('Webshare', 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 
    NULL, NULL, NULL, NULL, NULL, NULL, 5000);
            
            
INSERT INTO `wsuser` (`idUser`, `typeUser`, `nomUser`, `logUser`, `passUser`, 
   `serveurs`, `langUser`, `styleUser`, `visuUser`, `triUser`, `varsUser`, 
   `webUser`, `arboUser`, `auth1`, `auth2`, `auth3`, `auth4`, `auth5`, `auth6`, 
   `auth7`, `auth8`) VALUES 
   (1, 1, 'webAdmin', 'root', '63a9f0ea7bb98050796b649e85481845', 'Documents', 
   'Francais', 'Standard', 'miniatures', 'extension', 
   'webshare|admin|pass|moteur|htaccess|htpass|php|asp$|aspx$|ini$|pl$|cgi|js$|jsp$|dhtml$|cfm$|htm|sessions|Thumbs|wsminis|old$|~|^[.]{1}|^[.]{2}$|^[.]{1}$', 
   0, 1, 'on', 'on', 'on', 'on', 'on', 'on', 'on', 'on');
            
            
INSERT INTO `wsserver` (`idServeur`, `typeServeur`, `triServeur`, `nomServeur`, 
   `rootServeur`, `repServeur`, `startServeur`, `adrServeur`, `logServeur`, 
   `passServeur`, `portServeur`, `protectIndex`, `protectHtacc`, `binServeur`, 
   `protectServeur`) VALUES 
   (1, 1, 1, 'Documents', '$mydoc$', '', '', '', '', '', '', 0, 0, 0, 0);
   
            
INSERT INTO `wsasso` (`idasso`, `type`, `libelle`, `mime`, `action1`, `action2`) VALUES 
( 1, 'jpeg', 'Image Jpeg', 'image/jpeg', '6', '3'),
( 2, 'jpg', 'Image Jpeg', 'image/jpeg', '6', '3'),
( 3, 'png', 'Image Png', 'image/png', '6', '3'),
( 4, 'gif', 'Image Gif', 'image/gif', '6', '3'),
( 5, 'tif', 'Image Tiff', 'image/tiff', '2', '3'),
( 6, 'bmp', 'Image Bitmap', 'image/bmp', '6', '3'),
( 7, 'psd', 'Image Photoshop', 'x-vnd.adobe.photoshop', '2', '3'),
( 8, 'ai', 'Document Illustrator', 'application/postscript', '2', '3'),
( 9, 'indd', 'Document Indesign', 'application/postscript', '2', '3'),
(10, 'eps', 'Fichier PostScript', 'application/postscript', '3', '3'),
(11, 'ps', 'Fichier PostScript', 'application/postscript', '3', '3'),
(12, 'ttf', 'Fonte TrueType', 'application/x-font-TrueType', '3', '3'),
(13, 'otf', 'Fonte OpenType', 'application/x-font-TrueType', '3', '3'),
(14, 'pdf', 'Document portable', 'application/pdf', '1', '3'),
(15, 'doc', 'Document Word', 'application/msword', '2', '3'),
(16, 'xls', 'Classeur Excel', 'application/vnd.ms-excel', '2', '3'),
(17, 'ppt', 'Presentation Powerpoint', 'application/vnd.ms-powerpoint', '2', '3'),
(18, 'odt', 'Traitement de texte', 'application/vnd.oasis.opendocument.text', '2', '3'),
(19, 'ods', 'Tableur', 'application/vnd.oasis.opendocument.spreadsheet', '2', '3'),
(20, 'odp', 'Presentation', 'application/vnd.oasis.opendocument.presentation', '2', '3'),
(21, 'odg', 'Dessin', 'application/vnd.oasis.opendocument.graphics', '2', '3'),
(22, 'odf', 'Formule', 'application/vnd.oasis.opendocument.formula', '2', '3'),
(23, 'odb', 'Base de donnees', 'application/vnd.oasis.opendocument.database', '2', '3'),
(24, 'htm', 'Page web', 'text/html', '5', '1'),
(25, 'html', 'Page web', 'text/html', '5', '1'),
(26, 'xml', 'Document Xml', 'text/xml', '1', '2'),
(27, 'rss', 'Flux RSS', 'text/xml', '1', '2'),
(28, 'url', 'Lien Internet', 'text/plain', '5', 'editor'),
(29, 'rtf', 'Texte enrichi', 'application/rtf', '2', '3'),
(30, 'txt', 'Document texte', 'text/plain', '1', 'editor'),
(31, 'ini', 'Fichier de configuration', 'text/plain', '2', 'editor'),
(32, 'c', 'Script C', 'text/plain', '2', 'editor'),
(33, 'cpp', 'Script Cpp', 'text/plain', '2', 'editor'),
(34, 'php', 'Script PHP', 'text/plain', '1', 'editor'),
(35, 'asp', 'Script ASP', 'text/plain', '2', 'editor'),
(36, 'aspx', 'Script ASP.NET', 'text/plain', '2', 'editor'),
(37, 'js', 'Script Javascript', 'application/javascript', '2', 'editor'),
(38, 'css', 'Fichier de style', 'text/css', '1', 'editor'),
(39, 'sql', 'Base MySQL', 'text/plain', '1', '3'),
(40, 'log', 'Fichier de log', 'text/plain', '1', '3'),
(41, 'mp3', 'Audio MP3', 'audio/mp3', 'mp3player', 'flvplayer'),
(42, 'ogg', 'Audio Ogg', 'application/ogg', 'mp3player', '3'),
(43, 'wav', 'Fichier audio', 'audio/x-wav', '2', '3'),
(44, 'mid', 'Fichier midi', 'audio/x-midi', '2', '3'),
(45, 'm3u', 'Playlist audio', 'text/plain', '1', 'editor'),
(46, 'ra', 'RealMedia', 'audio/vnd.rn-realaudio', 'rmplayer', '3'),
(47, 'mov', 'Video Quicktime', 'video/mov', 'qtplayer', '3'),
(48, 'qt', 'Video Quicktime', 'video/quicktime', 'qtplayer', '3'),
(49, 'mpg', 'Video Mpeg', 'video/mpeg', 'mpgplayer', '3'),
(50, 'avi', 'Video Avi', 'video/msvideo', 'aviplayer', '3'),
(51, 'divx', 'Video Divx', 'video/divx', 'aviplayer', '3'),
(52, 'flv', 'Video Flash', 'video/flash', 'flvplayer', '3'),
(53, 'fla', 'Document Flash', 'application/x-flash', '2', '3'),
(54, 'swf', 'Animation Flash', 'application/x-shockwave-flash', '1', '3'),
(55, 'zip', 'Archive Zip', 'application/zip', '10', '3'),
(56, 'rar', 'Archive Rar', 'application/zip', '2', '3'),
(57, 'tar', 'Archive Tar', 'application/x-tar', '10', '3'),
(58, 'gz', 'Archive Tar', 'application/x-tar', '10', '3'),
(59, 'iso', 'Image disque', 'application/octet-stream', '3', '3'),
(60, 'java', 'Script Java', 'application/octet-stream', '3', '3'),
(61, 'dll', 'Librairie dynamique', 'application/octet-stream', '3', '3'),
(62, 'exe', 'Executable Windows', 'application/octet-stream', '3', '3'),
(63, 'tmp', 'Fichier temporaire', 'application/octet-stream', '3', '3');            
            