<?php
/************************************************************************/
/*                                WEBSHARE                              */
/************************************************************************/
//
// Copyright (c) 2008 by Virginie Vivancos
// http://www.webshare.fr
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License.
//
// =======================================================================
// Fonction : Définit des fonctions globales
// Nom      : fonctions.php
// Version  : 0.6.5
// Date     : 28/05/08
// =======================================================================

    if (preg_match("/MSIE/i", $_SERVER["HTTP_USER_AGENT"])==1)       $navig="IE";
elseif (preg_match("/KHTML/i",$_SERVER["HTTP_USER_AGENT"])==1)       $navig="KH";
elseif (preg_match("/opera/i",$_SERVER["HTTP_USER_AGENT"])==1)       $navig="OP";
elseif (preg_match("/^Mozilla\//i", $_SERVER["HTTP_USER_AGENT"])==1) $navig="MO";
                                                                else $navig="NS";
if ($navig=="IE") $instr= "client"; else $instr= "offset";
if ($navig=="IE") $filtre='filter:alpha(opacity=0)';
             else $filtre='opacity:0';

   // Fonctions de corrections de mise en forme des noms et liens
   function blindeNom($v_in) {
     $v_out = str_replace("&","&amp;",$v_in);
     convertUTF8($v_out);
     return $v_out;
   }

   function blindeLien($v_in) {
     $v_in  = utf8_encode(htmlspecialchars($v_in));
     $v_out = str_replace(array("%2F","%2F%2F","//","///","\\"),"/",$v_in);
    // $v_out = substr($v_out, 1);
     return $v_out;
   }

   function blindeChemin($v_in) {
     $v_out = str_replace(array("%2F","%2F%2F","//","///","\\"),"/",$v_in);
     return $v_out;
   }

   function blindeAffichage($v_in) {
     $v_out =  utf8_encode(str_replace("&","%26",$v_in));
     return $v_out;
   }

   // Retourne la racine serveur quelquesoit la configuration
   function getDocumentRoot() {
     if (!isset($_SERVER["DOCUMENT_ROOT"])||empty($_SERVER["DOCUMENT_ROOT"])) {
       $pathRoot= blindeChemin(isset($_SERVER["PATH_TRANSLATED"])?$_SERVER["PATH_TRANSLATED"]:$_SERVER["SCRIPT_FILENAME"]);
       $pathFile= blindeChemin(isset($_SERVER["SCRIPT_NAME"])?$_SERVER["SCRIPT_NAME"]:$_SERVER["PHP_SELF"]);
       if (empty($pathFile)) $pathFile= blindeChemin($_SERVER["ORIG_PATH_INFO"]);
       $docRoot= str_replace ($pathFile,"",$pathRoot)."/";
     } else {
       $docRoot= $_SERVER["DOCUMENT_ROOT"];
     }
     return $docRoot;
   }

   // Retourne la racine script quelquesoit la configuration
   function getScriptRoot() {
     $pathRoot= dirname(blindeChemin(isset($_SERVER["PATH_TRANSLATED"])?$_SERVER["PATH_TRANSLATED"]:$_SERVER["SCRIPT_FILENAME"]));
     return $pathRoot;
   }

   // Vérifie que le chemin ne contient pas de lien vers le niveau supérieur
   function verifie($nomChemin) {
     if (!isset($nomChemin)||empty($nomChemin)||(strstr(html_entity_decode($nomChemin),"..")!==false)||preg_match($_SESSION["varsUser"],html_entity_decode($nomChemin)))
       { echo $_SESSION["dia"]["noOperation"]; exit(); }
   }

  // Retourne les droits d'un fichier ou d'un dossier selon l'utilisateur
  function gestion($perms) {

   $iciPerm="";
    switch ($_SESSION["typeUser"]) {

    case 1:
    // Propriétaire
     if (($perms & 0x0100)&&($_SESSION["auth1"]=="on")) $iciPerm.= 'R';
     if (($perms & 0x0080)&&($_SESSION["auth3"]=="on")) $iciPerm.= 'W';
    break;

    case 2:
     // Groupe
     if (($perms & 0x0100)&&($perms & 0x0020)&&($_SESSION["auth1"]=="on")) $iciPerm.= 'R';
     if (($perms & 0x0080)&&($perms & 0x0010)&&($_SESSION["auth3"]=="on")) $iciPerm.= 'W';
    break;

    case 3: default:
     // Tous
     if (($perms & 0x0100)&&($perms & 0x0004)&&($_SESSION["auth1"]=="on")) $iciPerm.= 'R';
     if (($perms & 0x0080)&&($perms & 0x0002)&&($_SESSION["auth3"]=="on")) $iciPerm.= 'W';
    break;
    }

    if (empty($iciPerm)) $iciPerm="N";
    return $iciPerm;

  }

  // Retourne les droits FTP d'un fichier ou d'un dossier selon l'utilisateur
  function gestionFTP($perms) {
   $iciPerm="";
    switch ($_SESSION["typeUser"]) {

    case 1:
    // Propriétaire
     if ((substr($perms,1,1)=="r")&&($_SESSION["auth1"]=="on")) $iciPerm.= 'R';
     if ((substr($perms,2,1)=="w")&&($_SESSION["auth3"]=="on")) $iciPerm.= 'W';
    break;

    case 2:
     // Groupe
     if ((substr($perms,4,1)=="r")&&($perms & 0x0020)&&($_SESSION["auth1"]=="on")) $iciPerm.= 'R';
     if ((substr($perms,5,1)=="w")&&($perms & 0x0010)&&($_SESSION["auth3"]=="on")) $iciPerm.= 'W';
    break;

    case 3: default:
     // Tous
     if ((substr($perms,7,1)=="r")&&($perms & 0x0004)&&($_SESSION["auth1"]=="on")) $iciPerm.= 'R';
     if ((substr($perms,8,1)=="w")&&($perms & 0x0002)&&($_SESSION["auth3"]=="on")) $iciPerm.= 'W';
    break;
    }

    if (empty($iciPerm)) $iciPerm="N";
    return $iciPerm;
  }

  // Convertion de l'extended ASCII vers l'UTF8
  function ascToUtf8($val) {

    $convertTable= array(
      "128"=>"Ç", "129"=>"ü", "130"=>"é", "131"=>"â", "132"=>"ä", "133"=>"à", "135"=>"ç", "136"=>"ê", "137"=>"ë", "138"=>"è", "139"=>"ï",
      "140"=>"î", "141"=>"ì", "142"=>"Ä", "143"=>"Å", "144"=>"É", "145"=>"æ", "146"=>"Æ", "147"=>"ô", "148"=>"ö", "149"=>"ò", "150"=>"û",
      "151"=>"ù", "152"=>"ÿ", "153"=>"Ö", "154"=>"Ü", "160"=>"á", "161"=>"í", "162"=>"ó", "163"=>"ú", "164"=>"ñ", "165"=>"Ñ", "167"=>"°", "248"=>"°");
    return $convertTable[$val];
  }

   // Dézippe un fichier
   function dezipper($nomElement,$nomDestination) {

      include_once "zip.lib.php";
      $zip = zip_open(blindeChemin($nomElement));

      if ($zip) {
        while ($zip_entry = zip_read($zip)) {
          $filepath=str_replace("%2F", "/",urlencode(dirname(zip_entry_name($zip_entry))));
          $filename=urlencode(basename(zip_entry_name($zip_entry)));
          $filepath=preg_replace('~%([0-9a-f])([0-9a-f])~ei', 'ascToUtf8(hexdec("\\1\\2"))', $filepath);
          $filename=preg_replace('~%([0-9a-f])([0-9a-f])~ei', 'ascToUtf8(hexdec("\\1\\2"))', $filename);

          $taille= zip_entry_filesize($zip_entry);

          if (!is_dir(blindeChemin($nomDestination."/".$filepath))) mkdir (blindeChemin($nomDestination."/".$filepath));
           if (isset($filename)&&!empty($filename)&&(strstr(html_entity_decode($filename),"..")===false)&&!preg_match($_SESSION["varsUser"],html_entity_decode($filename))) {
            if ($taille!=0) {
              if (zip_entry_open($zip, $zip_entry, "r")) {
              if (!$handle = @fopen(blindeChemin("$nomDestination/$filepath/".$filename), 'w+'))
                return " msginfo=\"".$_SESSION["dia"]["cantOpen"]." (".blindeChemin("$nomDestination/$filepath/$filename").")\";";
              if (@fwrite($handle, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry))) === FALSE)
                return " msginfo=\"".$_SESSION["dia"]["cantwrite"]." (".blindeChemin("$nomDestination/$filepath/$filename").")\";";
              @fclose($handle);
              zip_entry_close($zip_entry);
            }
           }
          }

        }
        zip_close($zip);
     }
   }

  $erreur="";
  $old_error_handler = set_error_handler("myErrorHandler");

  // Fonction de gestion des erreurs
  function myErrorHandler($errno, $errstr, $errfile, $errline) {
    global $erreur;
        if ((preg_match("/Permission denied/", $errstr))==1) $erreur= @$_SESSION["dia"]["prohibited"];
    elseif ((preg_match("/File exist/", $errstr))==1)        $erreur= @$_SESSION["dia"]["fileExist"];
                                                        else $erreur= @$_SESSION["dia"]["identProblem2"];
                                                        $erreur= $errstr;
  }

  // Fonction de retour de la langue du navigateur
  function deflang() {
    switch(strtolower(substr($_SERVER['HTTP_ACCEPT_LANGUAGE'],0,2))) {
      case "us" : $deflang='English';   break;
      case "en" : $deflang='English';   break;
      case "fr" : $deflang='Francais';  break;
      case "ja" : $deflang='Japanese';  break;
      case "jp" : $deflang='Japanese';  break;
      case "de" : $deflang='Deutsch';   break;
      case "pt" : $deflang='Portugues'; break;
      case "br" : $deflang='Portugues'; break;
      case "es" : $deflang='Spanish';   break;
      case "ca" : $deflang='Catalan';   break;
      case "zh" : $deflang='Chinese';   break;
      case "ko" : $deflang='Korean';    break;
      default   : $deflang='English';   break;
    }
    return $deflang;
  }

  // Fonction de connexion à un serveur FTP
  function connexionFTP($nomFTP, $a) {
    #require('../cas_auth.php');
//    $a = $_SESSION['pts'];//cas_auth_get_pt();
    $conn_id = @ftp_connect($_SESSION["$nomFTP"]["adrServeur"]);
//    $login_result = @ftp_login($conn_id, $_SESSION["$nomFTP"]["logServeur"], base64_decode($_SESSION["$nomFTP"]["passServeur"]));

$login_result = @ftp_login($conn_id, $_SESSION['phpCAS']['user'], $a);
    //$login_result = @ftp_login($conn_id, $_SESSION["$nomFTP"]["logServeur"], $a);

    if ((!$conn_id) || (!$login_result)) return false;
                                  else { return $conn_id; }
  }

  // Fonction de chargement d'un fichier distant
  function ftp_get_contents($ftp_stream, $remote_file, $mode, $resume_pos=null){
    $name_file= basename($remote_file);
    @ftp_get($ftp_stream, blindeChemin($_SESSION["tempDir"]."/".$name_file), $remote_file, FTP_BINARY);
    $contenu= @file_get_contents(blindeChemin($_SESSION["tempDir"]."/".$name_file));
    @unlink (blindeChemin($_SESSION["tempDir"]."/".$name_file));
    return $contenu;
  }

  // Conversion en UTF8
  function convertUTF8($str) {
    if (!function_exists('mb_convert_encoding')) return $str;
    else {
      if ($str === mb_convert_encoding(mb_convert_encoding($str, "UTF-32", "UTF-8"), "UTF-8", "UTF-32"))
           return $str;
      else return mb_convert_encoding($str,"UTF-8");
    }
  }

  // Turns a string of unicode characters into an array of ordinal values,
  // Even if some of those characters are multibyte.
  function unistr_to_ords($str, $encoding = 'UTF-8'){
    $str = mb_convert_encoding($str,"UCS-4BE",$encoding);
    $ords = array();

    // Visit each unicode character
    for($i = 0; $i < mb_strlen($str,"UCS-4BE"); $i++){
      // Now we have 4 bytes. Find their total numeric value.
      $s2 = mb_substr($str,$i,1,"UCS-4BE");
      $val = unpack("N",$s2);
      $ords[] = $val[1];
    }
      return($ords);
  }

  // Fonction de conversion des caractères tapés par l'utilisateur
  // pour insertion dans le nom de fichier même si le serveur est incompatible
  function convCar($str) {
    if (function_exists('mb_convert_encoding')) {
      $result = unistr_to_ords($str); $nomCorrige="";

      foreach ($result as $valCar) {
        if ($valCar<=255) $nomCorrige.=chr($valCar);
                     else $nomCorrige.="%u".dechex($valCar); }

           return utf8_encode($nomCorrige);
    } else return $str;
  }

  function html_to_utf8($data) {
    $data= hexdec($data);
    if ($data > 127) {
      $i = 5;
      while (($i--) > 0) {
        if ($data != ($a = $data % ($p = pow(64, $i)))) {
          $ret = chr(base_convert(str_pad(str_repeat(1, $i + 1), 8, "0"), 2, 10) + (($data - $a) / $p));
          for ($i; $i > 0; $i--)
            $ret .= chr(128 + ((($data % pow(64, $i)) - ($data % ($p = pow(64, $i - 1)))) / $p));
            break; }
      }
    } else $ret = "&#$data;";
    return $ret;
  }

  function conversion($val) {
    $val = trim($val);
    $last = strtolower($val{strlen($val)-1});
    switch($last) {
      case 'g': $val *= 1024;
      case 'm': $val *= 1024;
      case 'k': $val *= 1024; break;
    }
    return $val;
  }

  // ==== Blinde les données mySQL ====
  function blinde_param($p_param) {
    foreach ($p_param as $l_key => $l_value) {
      if (is_string($l_value) && ($l_value == "")) $p_http[$l_key] = "";
      elseif (is_string($l_value)) $p_http[$l_key] = mysql_real_escape_string(stripslashes($l_value));
      elseif (is_array($l_value))  $p_http[$l_key] = blinde_param($l_value);
    }
    return $p_http;
  }

  // Fonction de log
  function logAction($idaction,$idresult,$verbose,$username,$path,$file,$content) {
    include_once "connexion.conf.php";
    if ($_SESSION["activeLog"]==1) {
      $ipadr=$_SERVER['REMOTE_ADDR'];
      $verbose=utf8_decode($verbose);
      if (mysql_ping($_SESSION["connectBase"])) {

        // ==== Ajout de l'action dans la base de données de log ====
        $request= "INSERT INTO wslog (idaction,idresult,iddate,verbose,username,path,file,content,ipadr)"
                 ."VALUES('$idaction','$idresult','".date("Y-m-d H:i:s")."','".addslashes($verbose)."','$username','$path','$file','".addslashes($content)."','$ipadr')";
        $result = mysql_query($request,$_SESSION["connectBase"]);
        mysql_free_result($result);
      } elseif (isset($_SESSION["repLog"])) {

        // ==== Ajout de l'action dans le fichier texte de log ====
        if (($dest = fopen($_SESSION["repLog"]."logs-".date("Ymd").".txt", "a+")) === FALSE) $erreur=1; else { $erreur = 0;
           fwrite ($dest,date("Y-m-d H:i:s")." \ $username ($ipadr) : ".$verbose." \n");
           fclose ($dest);
        }
      }
    }
  }

  // Fonction de coloration syntaxique
  function ColorPhpCode($Code) {

    $Color['html']    = '#00000';
    $Color['comment'] = '#008080';
    $Color['default'] = '#0000BB';
    $Color['keyword'] = '#007700';
    $Color['string']  = '#FF4000';

    $ret = highlight_string($Code, true);

    $in = array(
      '`</?code>`i',
      '`<(?:font color="|span style="color: )' .ini_get('highlight.html')   . '">(.+?)</(?:font|span)>`si',
      '`<(?:font color="|span style="color: )' .ini_get('highlight.comment'). '">(.+?)</(?:font|span)>`si',
      '`<(?:font color="|span style="color: )' .ini_get('highlight.default'). '">(.+?)</(?:font|span)>`si',
      '`<(?:font color="|span style="color: )' .ini_get('highlight.keyword'). '">(.+?)</(?:font|span)>`si',
      '`<(?:font color="|span style="color: )' .ini_get('highlight.string') . '">(.+?)</(?:font|span)>`si',
      '` `si'
    );

    $out = array(
      '',
      '<span class="html">$1</span>',
      '<span style="color:' .$Color['comment']. '">$1</span>',
      '<span style="color:' .$Color['default']. '">$1</span>',
      '<span style="color:' .$Color['keyword']. '">$1</span>',
      '<span style="color:' .$Color['string' ]. '">$1</span>',
      ' '
    );

    $ret= preg_replace($in, $out, $ret);
    $pieces= explode("<br />",$ret); $numLigne=1;
    $ret  = "<table border=0 cellspacing=0 cellpadding=0>\n";
    foreach ($pieces as $valeur)
      $ret.= "<tr><td class='cl'>".$numLigne++."</td><td class='cd'>&nbsp;".$valeur."</td></tr>\n";
      $ret .= "</table>";
    return $ret;
  }
?>
